//Adi Budau

#include <iostream>
#include <fstream>

using namespace std;

class Mstack {
  public:
    explicit Mstack(ostream& out):
            out_(out),
            left_(0),
            right_(0),
            bottom_(0) {
    }

    void push() {
        ++right_;
        out_ << "push 2\n";
        balance();
    }

    void pop() {
        if (right_ == 0)
            resize(1, left_, 2, right_);

        if (right_ == 0) {  // that means left is also empty
            out_ << "pop 3\n";
            --bottom_;
        } else {
            out_ << "pop 2\n";
            --right_;
        }

        balance();
    }

    void top() {
        if (right_ == 0)
            resize(1, left_, 2, right_);
        if (right_ == 0)
            out_ << "top 3\n";
        else
            out_ << "top 2\n";
    }

    void middle() {
        out_ << "top 3\n";
    }

  private:
    void resize(int from, int &fromsize, int to, int &tosize) {
        int newfromsize = fromsize / 2;
        int newtosize = fromsize - newfromsize;

        for (int i = 0; i < newfromsize; ++i) {
            out_ << "move " << from << " 3\n";
            --fromsize;
            ++bottom_;
        }

        for (int i = 0; i < newtosize; ++i) {
            out_ << "move " << from << " " << to << "\n";
            --fromsize;
            ++tosize;
        }

        for (int i = 0; i < newfromsize; ++i) {
            out_ << "move 3 " << from << "\n";
            --bottom_;
            ++fromsize;
        }
    }

    void balance() {
        int expected = left_ + right_ + bottom_;
        if (expected != 0)
            expected = (expected + 2) / 2;

        while (bottom_ < expected) {
            if (left_ == 0)
                resize(2, right_, 1, left_);
            out_ << "move 1 3\n";
            ++bottom_;
            --left_;
        }

        while (bottom_ > expected) {
            out_ << "move 3 1\n";
            --bottom_;
            ++left_;
        }
    }

    ostream& out_;

    int left_, right_, bottom_;
};

int main() {
    ifstream cin("mstack.in");
    ofstream cout("mstack.out");

    int N; cin >> N;

    Mstack M(cout);
    for (int i = 0; i < N; ++i) {
        string operation; cin >> operation;
        if (operation == "push")
            M.push();
        else if (operation == "pop")
            M.pop();
        else if (operation == "top")
            M.top();
        else
            M.middle();
    }
}
